install_kernel_headers.sh 2.3 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970
  1. #!/bin/sh
  2. # Parameters:
  3. # $1 = source dir
  4. # $2 = dst dir
  5. # $top_builddir = well you guessed it
  6. die_if_not_dir()
  7. {
  8. for dir in "$@"; do
  9. test -d "$dir" && continue
  10. echo "Error: '$dir' is not a directory"
  11. exit 1
  12. done
  13. }
  14. # Ensure that created dirs/files have 755/644 perms
  15. umask 022
  16. # Sanity tests
  17. die_if_not_dir "$1"
  18. mkdir -p "$2" 2>/dev/null
  19. die_if_not_dir "$2"
  20. die_if_not_dir "$top_builddir"
  21. # Just copy (no sanitization) some kernel headers.
  22. eval `grep ^KERNEL_HEADERS "$top_builddir/.config"`
  23. if ! test "$KERNEL_HEADERS" \
  24. || ! test -d "$KERNEL_HEADERS/asm" \
  25. || ! test -d "$KERNEL_HEADERS/asm-generic" \
  26. || ! test -d "$KERNEL_HEADERS/linux" \
  27. ; then
  28. echo "Error: '$KERNEL_HEADERS' is not a directory containing kernel headers."
  29. echo "Check KERNEL_HEADERS= in your .config file."
  30. exit 1
  31. fi
  32. # Do the copying only if src and dst dirs are not the same.
  33. # Be thorough: do not settle just for textual compare,
  34. # and guard against "pwd" being handled as shell builtin.
  35. # Double quoting looks weird, but it works (even bbox ash too).
  36. if test "`(cd "$KERNEL_HEADERS"; env pwd)`" != "`(cd "$2"; env pwd)`"; then
  37. # NB: source or target files and directories may be symlinks,
  38. # and for all we know, good reasons.
  39. # We must work correctly in these cases. This includes "do not replace
  40. # target symlink with real directory" rule. So, no rm -rf here please.
  41. mkdir -p "$2/asm" 2>/dev/null
  42. mkdir -p "$2/asm-generic" 2>/dev/null
  43. mkdir -p "$2/linux" 2>/dev/null
  44. # Exists, but is not a dir? That's bad, bail out
  45. die_if_not_dir "$2/asm" "$2/asm-generic" "$2/linux"
  46. # cp -HL creates regular destination files even if sources are symlinks.
  47. # This is intended.
  48. # (NB: you need busybox 1.11.x for this. earlier ones are slightly buggy)
  49. cp -RHL "$KERNEL_HEADERS/asm"/* "$2/asm" || exit 1
  50. cp -RHL "$KERNEL_HEADERS/asm-generic"/* "$2/asm-generic" || exit 1
  51. cp -RHL "$KERNEL_HEADERS/linux"/* "$2/linux" || exit 1
  52. if ! test -f "$2/linux/version.h"; then
  53. echo "Warning: '$KERNEL_HEADERS/linux/version.h' is not found"
  54. echo "in kernel headers directory specified in .config."
  55. echo "Some programs won't like that. Consider fixing it by hand."
  56. fi
  57. fi
  58. # Fix mode/owner bits
  59. cd "$2" || exit 1
  60. chmod -R u=rwX,go=rX . >/dev/null 2>&1
  61. chown -R `id | sed 's/^uid=\([0-9]*\).*gid=\([0-9]*\).*$/\1:\2/'` . >/dev/null 2>&1